;
; bank1.asm - bank1 assembler
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
BANK		= 1
		.include config.def
		.include makro.def
		.include consts.def
		.include external.ram
		.include internal.ram

		*= $8000

		.fill $4000,$55

		*= $a000
		.if DE32_EXISTS=0
config16test    .byte $ff
		.fi
		.byte $ff,$ff,$ff
		.include crosslnk.asm
		.include load.asm
		.include save.asm
		.include jiffydos.asm
		.include lowlevel.asm	;duplicated code!
		.include ram.asm	;duplicated code!
		.include ideserv.asm
		.include c128keyb.asm

buffer_start	.for iodhtoe=0,iodhtoe<MAX_BUFFERS,iodhtoe=iodhtoe+1
		.byte iodhtoe*8+ram_exp_buff_avail0
		.next

		.include read.asm
		.include path.asm
		.include misc.asm	;duplicated code!
		.include atapi.asm	;duplicated code!

		.include trap.asm

		*= $8000
		.include messages.asm	;duplicated code!
		.include errors.asm
		.include ds1302.asm
		.include setup.asm

		.if *>$9e5f
		.error "Bank1 block $8000-$9e60 over!"
		.fi
