;
; c128keyb.asm - C128 extended keyboard control
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		.if DE32_EXISTS=1

c128keys	.proc
                pha
                
                #ldatax $dc01
                eor #$ff
                bne ok
                
                sta $dc00
                
                lda $dc01
                cmp $dc01
                bne *-6
                stx $dc00
                
                cmp #$ff
                bne end
ender           lda #64
                sta $cb
                gne end

ok		lda #%11111110
		sta $d02f
                ldy #0
                lda #23		;no scroll (no key)
                sta $cb
ff2		lda $dc01
		cmp $dc01
                bne *-6
                ldx #8
ff              lsr
                bcs r
                sty $cb
r               iny
                dex
                bne ff
                sec
                rol $d02f
                cpy #24
                bne ff2

                lda #%11111000
                sta $d02f
                lda $dc01
		cmp $dc01
                bne *-6
                cmp #$ff
                beq ender
                
                ldy $cb
                lda tab2,y
                sta $28d
                lda tab,y
                bne oo
		lda zp_valid_exp
		bne nomon
		tsx
                inx ;aaa
                inx ;jsr
                lda $100,x
		cmp #<$ea7d
                bne nomon
                inx ;jsr
                lda $100,x
		cmp #>$ea7d
                bne nomon
		inx ;y    
		inx ;x
		inx ;a
		inx ;sp
		inx ;l
		inx ;h
		lda $100,x
		cmp #>nmi_return
		beq nomon
                pla
                pha
                and #15
                cmp #%00000011
                beq mon
                cmp #%00001111
                beq mon
nomon           lda #0
		sta $28d
		lda #64
oo              sta $cb
                
                lda #%11111000
                sta $d02f

end     	pla
		tay
                and #15
                cmp #$02
                bne nu
                lda #1
nu              and #3
                tax
                lda gc_h,x
                pha
                lda gc_l,x
                pha
                tya
                lsr
                lsr
                and #3
                tax
                lda gb_h,x
                pha
                lda gb_l,x
                pha

                #psr $eb48
                jmp exit2basic

mon		tax
		pla	;aaa
		pla	;jsr
                pla	;jsr
                lda #%11111000
                sta $d02f
                bit $dc0d
                txa
                lsr
                lsr
                dec $318
                jmp monitor
                
tab		.byte 0 		;help ($84)
		.byte 27		;8
                .byte 16		;5
                .byte 33		;tab ($09)
                .byte 59		;2
                .byte 11		;4
                .byte 24		;7
                .byte 56		;1
                
                .byte 45		;esc ($1b)
                .byte 40		;+
                .byte 43		;-
                .byte 34		;lf ($0a)
		.byte 1			;cr ($0d)
                .byte 19		;6
                .byte 32		;9
                .byte 8			;3
                
                .byte 64		;alt
                .byte 35		;0
                .byte 44		;.
                .byte 7    		;up
                .byte 7			;down
                .byte 2    		;left
                .byte 2			;right
                .byte 64 		;noscroll

tab2		.byte 0
		.byte 0
                .byte 0
                .byte 4
                .byte 0
		.byte 0
                .byte 0
                .byte 0

		.byte 4
		.byte 0
                .byte 0
                .byte 4
                .byte 0
		.byte 0
                .byte 0
                .byte 0

		.byte 0
		.byte 0
                .byte 0
                .byte 1
                .byte 0
		.byte 1
                .byte 0
                .byte 0

gc_l		.byte <(switch_16k+2)
		.byte <(switch_8k0-1)
                .byte <(switch_8k-1)
                .byte <(switch_norm-1)

gc_h		.byte >(switch_16k+2)
		.byte >(switch_8k0-1)
                .byte >(switch_8k-1)
                .byte >(switch_norm-1)

gb_l    	.byte <(switch_16k-1)
		.byte <(gotobank2-1)
		.byte <(gotobank3-1)
		.byte <(gotobank0-1)

gb_h    	.byte >(switch_16k-1)
		.byte >(gotobank2-1)
		.byte >(gotobank3-1)
		.byte >(gotobank0-1)

		.pend

		.fi
