;
; man_hi.asm - File manager upper half
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
printdir	.proc
		sei
		ldx #<$450
		lda #>$450
		ldy man_selectedwin
		beq *+6
		ldx #<$630
		lda #>$630

		stx m_p2
		stx m_p3
		sta m_p2+1
		eor #$d8^$04
		sta m_p3+1

		lda man_el_l,y
		sta m_p5
		lda man_el_h,y
		sta m_p5+1

		lda #11
		sta m_p4

		dec $1

lop		ldy man_selectedwin
		lda m_p5
		cmp man_files_l,y
		lda m_p5+1
		sbc man_files_h,y
		bcc uii

		lda #32
		ldy #27
ug		sta (m_p2),y
		dey
		bpl ug
		lda m_p2
		adc #40-1
		#jmps ide

uii		lda m_p5
		ldy m_p5+1
		cpy #1
		inc $1
		jsr calc_filepos
		dec $1

		ldy #26
		lda (m_p1),y
		bmi sel			;selected?
		dey
		lda (m_p1),y
sel		ldy #27
ui		sta (m_p3),y
		dey
		bpl ui
		inc m_p5
		bne *+4
		inc m_p5+1

		ldy #0
		lda (m_p1),y
		tax
		iny
		lda (m_p1),y
		inc $1
		jsr numtoasc16
		dec $1
		lda #32
r		cpy #5
		bcs i
		sta (m_p2),y
		iny
		bne r
i
		lda m_p2
		clc
		adc #3
		sta m_p2
		bcc *+4
		inc m_p2+1
		ldy #2
ly		.if SUPERCPU=1
		lda (m_p1),y
		tax
		.else
		lax (m_p1),y
		.fi
		lda cconv,x
		sta (m_p2),y
		iny
		cpy #25
		bne ly

		lda m_p2
		adc #40-3-1
ide		sta m_p2
		sta m_p3
		lda m_p2+1
		adc #0
		sta m_p2+1
		eor #$d8^$04
		sta m_p3+1

		dec m_p4
		bne lop

		inc $1
		cli
		rts
		.pend

mloaddir	.proc

		ldx #<$4cc
		ldy #>$4cc
		lda man_selectedwin
		beq *+6
		ldx #<$6ac
		ldy #>$6ac
		jsr drawwin
		.byte 18,4
		.word manager.txtloading

		dec $1
		lda #"$"
		sta m_p1
		lda #1
		sta ActualFNLength
		lda #m_p1
		sta ActualFilename
		ldx #$e0
		stx m_p2
		ldy #>man_dirmem1
		lda man_selectedwin
		beq *+4
		ldy #>man_dirmem2
		sty m_p1+1
		dey
		sty m_p2+1
		lda #0
		sta ActualFilename+1
		sta ActualSecAddr
		jsr newload_t
		lda $90
		eor #$40
		bne *+4
		bcc ok
		ldy #31
		lda #32
l		sta (m_p2),y		;erase disklabel
		dey
		bpl l
		ldx man_selectedwin
		lda #0
		sta man_files_l,x
		sta man_files_h,x
		sta man_fulllo,x
		sta man_fullhi,x
		sta man_fullfree,x
		sta man_partition,x
		geq null

ok		tya
		sec
		sbc #>man_dirmem1
		sta m_p3
		txa
		lsr m_p3
		ror
		lsr m_p3
		ror
		lsr m_p3
		ror
		lsr m_p3
		ror
		lsr m_p3
		ror
		ldx man_selectedwin
		sta man_files_l,x
		eor #255
		clc
		adc #1
		sta m_p5
		lda m_p3
		and #1
		sta man_files_h,x
		eor #255
		adc #0
		sta m_p5+1

		ldy #2
		lda (m_p2),y
		sta man_partition,x
		inc m_p2+1

		ldx #0
		stx m_p1
		stx m_p2
		stx m_p4

		bcs null2

p		ldy #0
		lda (m_p2),y
		sta (m_p1),y
		iny
		lda (m_p2),y
		sta (m_p1),y		;copy filesize
		iny
ll		lda (m_p2),y
		cmp #34
		beq fi
		inc m_p2
		bne ll

f		lda (m_p2),y
		cmp #34
		beq ff
fi		sta (m_p1),y
		iny
		cpy #25
		bne f
		geq ry

ff		lda #0
		.byte SKIP2
f2		lda (m_p2),y
		sta (m_p1),y
		iny
		cpy #25
		bne f2

ry
		ldy #21
		lda (m_p1),y
		cmp #"D"
		bne nd
		iny
		lda (m_p1),y
		cmp #"I"
		bne nd
		iny
		lda (m_p1),y
		cmp #"R"
		bne nd

		ldy #3
		lda (m_p1),y
		cmp #"."
		bne nemp
		iny
		lda (m_p1),y
		beq rh			;"." found
		cmp #"."
		bne nemp
		iny
		lda (m_p1),y		;".." found
		bne nemp
rh		ldx man_selectedwin
		lda man_files_l,x
		bne h
		dec man_files_h,x
h		dec man_files_l,x
		jmp id
nemp
		sec
		.BYTE SKIP1
nd		clc

		#sta_cfg_open
		lda manager_filecolor_exp
		bcc iy
		lda manager_dircolor_exp
iy		#sta_cfg_16

		ldy #25
		sta (m_p1),y

		#sta_cfg_open
		lda manager_selfilecolor_exp
		bcc iy2
		lda manager_seldircolor_exp
iy2		#sta_cfg_16

		iny
		sta (m_p1),y

		lda m_p1
		clc
		adc #32
		sta m_p1
		bcc *+4
		inc m_p1+1

id		lda m_p4
		clc
		adc #32
		sta m_p4
		sta m_p2
		bcc *+4
		inc m_p2+1

		inc m_p5
		bne p
		inc m_p5+1
		bne p

null2		ldx man_selectedwin
		ldy #0
		lda (m_p2),y
		sta man_fulllo,x
		iny
		lda (m_p2),y
		sta man_fullhi,x

		ldy #9
		lda (m_p2),y
		sta man_fullfree,x

null		ldy #31
ig		lda pontpont,y
		sta man_pontpont,y
		dey
		bpl ig
		#sta_cfg_open
		lda manager_dircolor_exp
		#sta_cfg_16
		sta man_pontpont+25
		sta man_pontpont+26

		lda #0
		sta man_block_l,x
		sta man_block_m,x
		sta man_block_h,x
		sta man_filessel_l,x
		sta man_filessel_h,x

		inc $1
		jsr read_errchannel
		jmp showerror

pontpont	.word 0
		.text 34,".",".",0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,"D","I","R","<",32,32,32,0,1,1
		.pend

man_ext		.proc
		dec $1
		ldy #21
		lda (m_p1),y
		pha
		iny
		lda (m_p1),y
		tax
		iny
		lda (m_p1),y
		tay
		pla
		inc $1
		rts
		.pend

man_sel		.proc
		dec $1
		ldy #26
		eor (m_p1),y
		php
		inc $1
		plp
		rts
		.pend

man_copyfname	.proc
		dec $1
		ldy #3
                ldx #0
ry		lda (m_p1),y
		beq iu
		sta $201,x
                inx
		iny
		bpl ry
iu		lda #","
		sta $201,x
                inx
                ldy #21
xp              lda (m_p1),y
                cmp #32
                beq wx
                sta $201,x
                inx
                iny
                cpy #24
                bne xp
wx              

                lda #<$201
                sta ActualFilename
                lda #>$201
                sta ActualFilename+1
		stx ActualFNLength
		stx $200
		inc $1
		rts
		.pend

man_setupfname	.proc
		dec $1
		ldy #2
fg		iny
		beq f
		lda (m_p1),y
		bne fg
f
		dey
		dey
		dey
		sty ActualFNLength

		lda m_p1
		clc
		adc #3
		sta ActualFilename
		lda m_p1+1
		adc #0
		sta ActualFilename+1
		inc $1
		rts
		.pend

man_cd2		.proc
		lda #"/"
		ldx #"0"
		gne man_cd.in

man_cd		.proc
		lda #"C"
		ldx #"D"
in		ldy #0
		sta (m_p1),y
		iny
		txa
		sta (m_p1),y
		iny
		lda #":"
		sta (m_p1),y

		jsr man_setupfname

		lda m_p1
		sta ActualFilename
		lda m_p1+1
		sta ActualFilename+1
		inc ActualFNLength
		inc ActualFNLength
		inc ActualFNLength

		lda #15
		sta ActualSecAddr
		sta ActualLogical

		jmp read_errchannel.in
		.pend

man_toggle_sel	.proc
		lda m_p1+1
		cmp #>man_dirmem1
		bcc tu
		dec $1
		ldy #26
		lda (m_p1),y
		eor #128
		sta (m_p1),y
		asl
		ldx man_selectedwin
		ldy #0
		lda man_block_l,x
		bcs nc
		sec
		sbc (m_p1),y
		sta man_block_l,x
		lda man_filessel_l,x
		bne hp
		dec man_filessel_h,x
hp		dec man_filessel_l,x
		iny
		lda man_block_m,x
		sbc (m_p1),y
		bcs nc2
		dec man_block_h,x
		gcc nc2

nc		inc man_filessel_l,x
		bne hp2
		inc man_filessel_h,x
hp2		clc
		adc (m_p1),y
		sta man_block_l,x
		iny
		lda man_block_m,x
		adc (m_p1),y
		bcc nc2
		inc man_block_h,x
nc2		sta man_block_m,x
		inc $1
tu		rts
		.pend

sortdir		.proc
		lda #<man_sort1_l
		sta m_p1
		sta m_p2
		ldy #>man_sort1_l
		lda #>man_dirmem1
		ldx man_selectedwin
		beq *+6
		ldy #>man_sort2_l
		lda #>man_dirmem2
		sty m_p1+1
		iny
		iny
		sty m_p2+1
		sta m_p5+1
		lda #0
		sta m_p5
		sta man_l_l+63
		sta man_i_l+63
		lda #1
		sta man_l_h+63
		sta man_i_h+63

		ldy #0
		lda man_floppy,x
		bne flo
		lda #<man_pontpont
		sta (m_p1),y
		lda #>man_pontpont
		sta (m_p2),y
		inc man_l_l+63
		inc man_i_l+63
		inc man_files_l,x
		bne rg
		inc man_files_h,x
rg		iny

flo		lda man_files_l,x
		ora man_files_h,x
		beq err
		lda man_files_l,x
		eor #255
		sta m_p3
		lda man_files_h,x
		eor #255
		sta m_p3+1

		clc
idc		inc m_p3
		bne gc
		inc m_p3+1
		beq en
gc		lda m_p5
		sta (m_p1),y		;unsorted
		adc #32
		sta m_p5
		lda m_p5+1
		bcc ip
		clc
		inc m_p5+1
ip		sta (m_p2),y
		iny
		bne idc
		inc m_p1+1
		inc m_p2+1
		gne idc

en		ldy man_selectedwin
		lda man_floppy,y
		bne err			;no sorting for floppy
		lda man_files_l,y
		sec
		sbc #1
		sta man_r_l+63
		lda man_files_h,y
		sbc #0
		sta man_r_h+63
		inc man_r_h+63
		bcc err
		lda man_l_l+63
		cmp man_r_l+63
		lda man_l_h+63
		sbc man_r_h+63
		bge err
		dec $1
		sei
		ldx #64
		jsr quicksort
		cli
		inc $1
err		inx
		rts

quicksort	dex
		beq err
		lda man_r_l,x		;j=r
		sta man_j_l,x
		clc
		adc man_l_l,x
		pha
		lda man_r_h,x
		sta man_j_h,x
		adc man_l_h,x
		ror
		tay
		pla
		ror
		cpy #2
		jsr calc_filepos	;buf1=xx[(l+r)/2];
		lda m_p1
		sta m_p2
		lda m_p1+1
		sta m_p2+1

repeat
lp1		lda man_i_l,x
		ldy man_i_h,x
		cpy #2
		jsr calc_filepos

		ldy #21
		lda (m_p1),y
		cmp #"D"
		bne e11
		iny
		lda (m_p1),y
		cmp #"I"
		bne e1
		iny
		lda (m_p1),y
		cmp #"R"
		bne e1

		cmp (m_p2),y
		bne nn1n
		dey
		lda (m_p2),y
		cmp #"I"
		bne nn1n
		dey
		lda (m_p2),y
		cmp #"D"
		bne nn1n
		geq ee1

e1		ldy #21
e11		lda (m_p2),y
		cmp #"D"
		bne ee1
		iny
		lda (m_p2),y
		cmp #"I"
		bne ee1
		iny
		lda (m_p2),y
		cmp #"R"
		beq i

ee1		ldy #3
l1		lda (m_p2),y
		beq i
		cmp (m_p1),y
		bne nn1
		iny
		bne l1
		geq i

nn1		bcc i

nn1n		inc man_i_l,x
		bne lp1
		inc man_i_h,x
		jmp lp1
i

lp2		lda man_j_l,x
		ldy man_j_h,x
		cpy #2
		jsr calc_filepos

		ldy #21
		lda (m_p2),y
		cmp #"D"
		bne e22
		iny
		lda (m_p2),y
		cmp #"I"
		bne e2
		iny
		lda (m_p2),y
		cmp #"R"
		bne e2

		cmp (m_p1),y
		bne nn2n
		dey
		lda (m_p1),y
		cmp #"I"
		bne nn2n
		dey
		lda (m_p1),y
		cmp #"D"
		bne nn2n
		geq ee2

e2		ldy #21
e22		lda (m_p1),y
		cmp #"D"
		bne ee2
		iny
		lda (m_p1),y
		cmp #"I"
		bne ee2
		iny
		lda (m_p1),y
		cmp #"R"
		beq i2

ee2		ldy #3
l2		lda (m_p1),y
		beq i2
		cmp (m_p2),y
		bne nn2
ok2		iny
		bne l2
		geq i2

nn2		bcc i2

nn2n		lda man_j_l,x
		bne rp
		dec man_j_h,x
rp		dec man_j_l,x
		jmp lp2

i2
		lda man_j_l,x		;if (i<=j)
		cmp man_i_l,x
		lda man_j_h,x
		sbc man_i_h,x
		blt th

		lda man_i_l,x
		sta m_p1
		sta m_p3
		lda man_j_l,x
		sta m_p4
		sta m_p5
		lda #>man_sort1_l
		ldy man_selectedwin
		beq *+6
		ldy #0
		lda #>man_sort2_l

		sta m_p1+1
		sta m_p4+1
		clc
		adc #2
		sta m_p3+1
		sta m_p5+1

		lda man_i_h,x
		cmp #2
		bcc *+6
		inc m_p1+1
		inc m_p3+1

		lda man_j_h,x
		cmp #2
		bcc *+6
		inc m_p4+1
		inc m_p5+1

		lda (m_p1),y		;push i
		pha
		lda (m_p3),y
		pha

		lda (m_p4),y
		sta (m_p1),y
		lda (m_p5),y
		sta (m_p3),y

		pla
		sta (m_p5),y
		pla
		sta (m_p4),y

		inc man_i_l,x
		bne rr
		inc man_i_h,x
rr
		lda man_j_l,x
		bne rr2
		dec man_j_h,x
rr2		dec man_j_l,x

th
		lda man_j_l,x		;if (i<=j)
		cmp man_i_l,x
		lda man_j_h,x
		sbc man_i_h,x
		bge repeat

		lda man_l_l,x
		cmp man_j_l,x
		lda man_l_h,x
		sbc man_j_h,x
		bge n1

		lda man_l_l,x
		sta man_l_l-1,x
		sta man_i_l-1,x
		lda man_l_h,x
		sta man_l_h-1,x
		sta man_i_h-1,x
		lda man_j_l,x
		sta man_r_l-1,x
		lda man_j_h,x
		sta man_r_h-1,x
		jsr quicksort
n1
		lda man_i_l,x
		cmp man_r_l,x
		lda man_i_h,x
		sbc man_r_h,x
		bge n2

		lda man_i_l,x
		sta man_l_l-1,x
		sta man_i_l-1,x
		lda man_i_h,x
		sta man_l_h-1,x
		sta man_i_h-1,x
		lda man_r_l,x
		sta man_r_l-1,x
		lda man_r_h,x
		sta man_r_h-1,x
		jsr quicksort
n2
		inx
		rts
		.pend

calc_filepos_cursor .proc
		ldx man_selectedwin
		lda man_el_l,x
		clc
		adc man_bar,x
		bcs calc_filepos
		ldy man_el_h,x
		cpy #1

calc_filepos	.proc
		tay
		lda man_selectedwin
		bcc e
		bne ee1

		lda man_sort1_l+256,y
		sta m_p1
		lda man_sort1_h+256,y
		sta m_p1+1
		rts

ee1		lda man_sort2_l+256,y
		sta m_p1
		lda man_sort2_h+256,y
		sta m_p1+1
		rts

e		bne ee2

		lda man_sort1_l,y
		sta m_p1
		lda man_sort1_h,y
		sta m_p1+1
		rts

ee2		lda man_sort2_l,y
		sta m_p1
		lda man_sort2_h,y
		sta m_p1+1
		rts

		rts
		.pend

man_plugin	.proc
		ldx #pl2-pl1-1
uk	     	lda pl1,x
		sta cconv+12
                ldy #21
                cmp (m_p1),y
                bne x
		lda pl2,x
		sta cconv+13
		iny
                cmp (m_p1),y
                bne x
		lda pl3,x
		sta cconv+14
                iny
                cmp (m_p1),y
                beq q
x		dex
		bpl uk
q		rts
                
pl1		.text "AAAAADDDFFHIKLLMSSSTX"
pl2             .text "FMNRS6RRLUPFLBNPHHI65"
pl3             .text "LIIKM4LPINILARXIFID4S"
                
		.pend
